<?php

namespace App\DataTables;

use App\Models\ListinoPrezzi;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;

use Illuminate\Support\Facades\Auth;

class  ListinoPrezziDataTableEditor extends DataTablesEditor
{
  protected $model = ListinoPrezzi::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'label.required' => 'Il label è richiesto',
    'descrizione.required' => 'La descrizione è richiesta',
    'tipo_dispositivo.required' => 'Il tipo di dispositivo è richiesto',
    'prezzo.required' => 'Il prezzo è richiesto',
    'tipo_prezzo.required' => 'Il tipo di prezzo è richiesto',
    'note.required' => 'La nota è richiesta',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    if(!Auth::user()->hasRole('superadmin')){
      return 403;
    }
    return [
      'label'  => 'required|string|max:255',
      'descrizione' => 'nullable|string|max:255',
      'tipo_dispositivo' => 'required',
      'prezzo' => 'required|numeric |min:0',
      'tipo_prezzo' => 'required|string|max:255',
      'note' => 'nullable|string|max:255',
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    if(!Auth::user()->hasRole('superadmin')){
      return 403;
    }
    return [
      'label'  => 'required|string|max:255',
      'descrizione' => 'nullable|string|max:255',
      'tipo_dispositivo' => 'nullable',
      'prezzo' => 'required|numeric |min:0',
      'tipo_prezzo' => 'required|string|max:255',
      'note' => 'nullable|string|max:255',
    ];
  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    return $data;
  }

  public function messages(): array
  {
    return $this->messages;
  }

}
